package jp.halfmoon.inaba.aiwolf.guess;

import jp.halfmoon.inaba.aiwolf.condition.AndCondition;
import jp.halfmoon.inaba.aiwolf.condition.OrCondition;
import jp.halfmoon.inaba.aiwolf.condition.RoleCondition;
import jp.halfmoon.inaba.aiwolf.learn.AgentStatistics;
import org.aiwolf.client.lib.Topic;
import org.aiwolf.client.lib.Utterance;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Talk;
import org.aiwolf.common.data.Team;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;

/**
 * uOڐg݂vNX
 */
public final class Learn_0dProtectCompany extends AbstractGuessStrategy {

	AgentStatistics agentStatistics;

	public Learn_0dProtectCompany(AgentStatistics agentStatistics){
		this.agentStatistics = agentStatistics;
	}

	@Override
	public ArrayList<Guess> getGuessList(GuessStrategyArgs args) {
		// Xg
		ArrayList<Guess> guesses = new ArrayList<Guess>();


		// 0ڂ͍sȂ
		if( args.agi.latestGameInfo.getDay() == 0 ){
			return guesses;
		}


		for( int agentNo = 1; agentNo <= args.agi.gameSetting.getPlayerNum(); agentNo++ ){

			// \z
			HashSet<Integer> protectAgent = new HashSet<Integer>();

			boolean isSaidVillager = false;
			for( Talk talk : args.agi.getTalkList(0) ){

				if( talk.getAgent().getAgentIdx() == agentNo ){
					Utterance ut = args.agi.getUtterance(talk.getContent());
					if( ut.getTopic() == Topic.ESTIMATE  ){
						if( args.agi.latestGameInfo.getAgentList().contains(ut.getTarget()) ){
							if( ut.getRole().getTeam() == Team.VILLAGER ) {
								protectAgent.add(ut.getTarget().getAgentIdx());
							}
						}
					}
				}
			}

			//TODO ҐΉ
			// \z1`12l̏ꍇɐsi13lƈ͂100%j
			if( !protectAgent.isEmpty() && protectAgent.size() <= 12 ){

				int estimateVillagerCount = agentStatistics.statistics.get(agentNo).eventCount.get(Role.WEREWOLF).getOrDefault("Said0dEstimateVillager", 0);
				int protectCompanyCount = agentStatistics.statistics.get(agentNo).eventCount.get(Role.WEREWOLF).getOrDefault("0dProtectCompany", 0);

				// 񂪂Tȏ゠ΐs
				if( estimateVillagerCount > 5 ){
					// PTŔ݂ĂȂ
					double measurementNotProtectRate = 1.0 - (double)protectCompanyCount / estimateVillagerCount;

					// ݂ĂȂm̗_l
					double theoreticalNotProtectRate = 1.0;
					for( int i = 0; i < protectAgent.size(); i++ ){
						theoreticalNotProtectRate *= ( (double)(12 - i)  / (14 - i) );
					}

					// ݂ĂȂ̗_lɑ΂{
					double rate = measurementNotProtectRate / theoreticalNotProtectRate;

					if( rate > 1.0 ){
						// ݂ĂȂ{
						RoleCondition wolfCondition = RoleCondition.getRoleCondition( agentNo, Role.WEREWOLF );
						OrCondition subCondition = new OrCondition();
						for( Integer i : protectAgent ){
							subCondition.addCondition(RoleCondition.getRoleCondition( i, Role.WEREWOLF ));
						}
						Guess guess = new Guess();
						guess.condition = new AndCondition().addCondition(wolfCondition).addCondition(subCondition);
						guess.correlation = Math.pow( Math.max(1.0 / rate, 0.5) , 1.0 );
						guesses.add(guess);
					}else{
						// ݂Ă{
						RoleCondition wolfCondition = RoleCondition.getRoleCondition( agentNo, Role.WEREWOLF );
						AndCondition subCondition = new AndCondition();
						for( Integer i : protectAgent ){
							subCondition.addCondition(RoleCondition.getNotRoleCondition( i, Role.WEREWOLF ));
						}
						Guess guess = new Guess();
						guess.condition = new AndCondition().addCondition(wolfCondition).addCondition(subCondition);
						guess.correlation = Math.pow( Math.max(rate, 0.5) , 1.0 );
						guesses.add(guess);
					}

				}

			}

		}

		// XgԂ
		return guesses;
	}

}
