package jp.halfmoon.inaba.aiwolf.guess;

import java.util.ArrayList;
import java.util.HashSet;

import jp.halfmoon.inaba.aiwolf.condition.OrCondition;
import jp.halfmoon.inaba.aiwolf.condition.RoleCondition;
import jp.halfmoon.inaba.aiwolf.lib.CauseOfDeath;
import jp.halfmoon.inaba.aiwolf.lib.Judge;

import org.aiwolf.client.lib.Topic;
import org.aiwolf.client.lib.Utterance;
import org.aiwolf.common.data.Agent;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Talk;
import org.aiwolf.common.data.Team;
import org.aiwolf.common.net.GameSetting;

/**
 * umCYvNX
 */
public final class Noise extends AbstractGuessStrategy {

	@Override
	public ArrayList<Guess> getGuessList(GuessStrategyArgs args) {

		// Xg
		ArrayList<Guess> guesses = new ArrayList<Guess>();

		GameSetting gameSetting = args.agi.gameSetting;


		// YG[WFgi[ϐ
		HashSet<Agent> othersCO = new HashSet();		// COΏۂȊO
		HashSet<Agent> enemySideCO = new HashSet();		// PPȂ󋵂ł̐lOCO
		HashSet<Agent> invalidAgent = new HashSet();	// ȃG[WFgւ̔
		HashSet<Agent> invalidAction = new HashSet();	// ȍs錾
		HashSet<Agent> emptyTalk = new HashSet();		// ӖȔ
		HashSet<Agent> invalidJudge = new HashSet();	// Ȕo


		// SĂ̔mF
		for( int day = 0; day <= args.agi.latestGameInfo.getDay(); day++ ){
			for( Talk talk : args.agi.getTalkList(day) ){

				double correlation = 1.0;

				// ̏ڍׂ̎擾
				Utterance utterance = args.agi.getUtterance(talk.getContent());

				// Ӕ̏ꍇÄӖ擾
				if( utterance.getTopic() == Topic.AGREE ){
					utterance = args.agi.getMeanFromAgreeTalk(talk, 0);
					// ͕s\
					if( utterance == null ){
						invalidAction.add(talk.getAgent());
						continue;
					}
				}

				switch( utterance.getTopic() ){
					case COMINGOUT:
						// COΏۂȊO
						if( utterance.getTarget().getAgentIdx() != talk.getAgent().getAgentIdx() ){
							othersCO.add(talk.getAgent());
						}
						// PPȂ󋵂ł̐lOCO
						if( utterance.getRole().getTeam() != Team.VILLAGER ){
							int wolfSideNum = gameSetting.getRoleNum(Role.WEREWOLF) + gameSetting.getRoleNum(Role.POSSESSED);
							if( args.agi.dayInfoList.get(day).aliveAgentList.size() > wolfSideNum * 2 ){
								enemySideCO.add(talk.getAgent());
							}
						}
						break;
					case VOTE:
						// Ώۂ݂Ȃ
						if( !args.agi.isValidAgentNo( utterance.getTarget().getAgentIdx() ) ){
							invalidAgent.add(talk.getAgent());
							break;
						}
						// Ώۂ
						if( utterance.getTarget().getAgentIdx() == talk.getAgent().getAgentIdx() ){
							invalidAction.add(talk.getAgent());
						}
						// _őΏۂSĂ
						if( args.agi.getCauseOfDeath( utterance.getTarget().getAgentIdx(), talk.getDay() ) != CauseOfDeath.ALIVE  ){
							invalidAction.add(talk.getAgent());
						}
						break;
					case ESTIMATE:
						// Ώۂ݂Ȃ
						if( utterance.getTarget().getAgentIdx() < 1 || utterance.getTarget().getAgentIdx() > args.agi.gameSetting.getPlayerNum() ){
							invalidAgent.add(talk.getAgent());
							break;
						}
						// Ώۂ
						if( utterance.getTarget().getAgentIdx() == talk.getAgent().getAgentIdx() ){
							emptyTalk.add(talk.getAgent());
						}
						break;
					case DISAGREE:
						// ̈Ӗ͕s\
						emptyTalk.add(talk.getAgent());
						break;
					default:
						break;
				}
			}
		}


		// SĂ̐蔻mF
		for( Judge judge : args.agi.getSeerJudgeList() ){
			// sȔo(COɔoȂ)
			if( judge.talk.equals(judge.cancelTalk) ){
				invalidJudge.add(Agent.getAgent(judge.agentNo));
			}
		}


		// SĂ̗씻mF
		for( Judge judge : args.agi.getMediumJudgeList() ){
			// sȔo(COɔoȂ)
			if( judge.talk.equals(judge.cancelTalk) ){
				invalidJudge.add(Agent.getAgent(judge.agentNo));
			}
		}



		for( Agent agent : args.agi.latestGameInfo.getAgentList() ){

			double correlation = 1.0;

			// COΏۂȊO
			if( othersCO.contains(agent) ){
				correlation *= 1.50;
			}
			// PPȂ󋵂ł̐lOCO
			if( enemySideCO.contains(agent) ){
				correlation *= 1.50;
			}
			// ȃG[WFgւ̔
			if( invalidAgent.contains(agent) ){
				correlation *= 1.30;
			}
			// ȍs錾
			if( invalidAction.contains(agent) ){
				correlation *= 1.05;
			}
			// ӖȔ
			if( emptyTalk.contains(agent) ){
				correlation *= 1.02;
			}
			// Ȕo
			if( invalidJudge.contains(agent) ){
				correlation *= 1.60;
			}

			// WɕωꍇAǉ
			if( Double.compare(correlation, 1.0) != 0 ){
				// ΏۂTor̃p^[Z
				RoleCondition wolfCondition = RoleCondition.getRoleCondition( agent.getAgentIdx(), Role.WEREWOLF );
				RoleCondition posCondition = RoleCondition.getRoleCondition( agent.getAgentIdx(), Role.POSSESSED );

				Guess guess = new Guess();
				guess.condition = new OrCondition().addCondition(wolfCondition).addCondition(posCondition);
				guess.correlation = correlation;
				guesses.add(guess);
			}

		}

		// XgԂ
		return guesses;
	}

}
