package jp.halfmoon.inaba.aiwolf.guess;

import java.util.ArrayList;
import java.util.List;

import jp.halfmoon.inaba.aiwolf.condition.AbstractCondition;
import jp.halfmoon.inaba.aiwolf.condition.AndCondition;
import jp.halfmoon.inaba.aiwolf.condition.RoleCondition;
import jp.halfmoon.inaba.aiwolf.lib.CauseOfDeath;

import jp.halfmoon.inaba.aiwolf.lib.VoteAnalyzer;
import org.aiwolf.common.data.Role;
import org.aiwolf.common.data.Vote;

/**
 * u[vNX
 */
public final class VoteRecent extends AbstractGuessStrategy {

	@Override
	public ArrayList<Guess> getGuessList(GuessStrategyArgs args) {

		// Xg
		ArrayList<Guess> guesses = new ArrayList<Guess>();


		// SĂ̓[mF(񓊕[=1)
		for( int day = 1; day < args.agi.latestGameInfo.getDay(); day++ ){

			// CO҂̃Xg擾
			List<Integer> mediums = args.agi.getEnableCOAgentNo(Role.MEDIUM, day, 0);

			for( Vote vote : args.agi.getVoteList(day) ){

				int voteAgentNo = vote.getAgent().getAgentIdx();
				int voteTargetNo = vote.getTarget().getAgentIdx();

				// [̐vfƂĂ̏d(菇݂肾ƌyȂ)
				double weight = 1.0;

				// 퓊[҂̏ꍇA菇݂Ƃďd݂
				if( mediums.size() >= 2 && mediums.indexOf(vote.getTarget().getAgentIdx()) != -1 ){
					weight *= 0.5;
				}
				// 퓊[҂Ⴂ̏ꍇA菇݂Ƃďd݂
				if( args.agi.isReceiveWolfJudge(vote.getTarget().getAgentIdx(), day, 0) ){
					weight *= 0.5;
				}

				//TODO @𒚔Jɂ
				// _mlȌꍇAd݂
				Role agentRole = args.agi.getCORole(voteAgentNo, day, 0);
				Role targetRole = args.agi.getCORole(voteTargetNo, day, 0);
				if( agentRole != null && targetRole != null && agentRole == targetRole ){
					weight *= 0.3;
				}

				AbstractCondition agentWolf = RoleCondition.getRoleCondition( voteAgentNo, Role.WEREWOLF );
				AbstractCondition agentPossessed = RoleCondition.getRoleCondition( voteAgentNo, Role.POSSESSED );
				AbstractCondition targetWolf = RoleCondition.getRoleCondition( voteTargetNo, Role.WEREWOLF );
				AbstractCondition targetNotWolf = RoleCondition.getNotRoleCondition( voteTargetNo, Role.WEREWOLF );

				Guess guess;
				// TT̃p^[𔖂iC؂j
				if( args.agi.agentState[voteAgentNo].causeofDeath != CauseOfDeath.ATTACKED &&
				    args.agi.agentState[voteTargetNo].causeofDeath != CauseOfDeath.ATTACKED){
					guess = new Guess();
					guess.condition = new AndCondition().addCondition(agentWolf).addCondition(targetWolf);
					guess.correlation = 1.0 - 0.4 * weight;
					guesses.add(guess);
				}

				// TT̃p^[ZiXP[vS[gj
				if( args.agi.agentState[voteAgentNo].causeofDeath != CauseOfDeath.ATTACKED ){
					guess = new Guess();
					guess.condition = new AndCondition().addCondition(agentWolf).addCondition(targetNotWolf);
					guess.correlation = 1.0 + 0.020 * weight;
					guesses.add(guess);
				}

				// T̃p^[ZiXP[vS[gj
				guess = new Guess();
				guess.condition = new AndCondition().addCondition(agentPossessed).addCondition(targetNotWolf);
				guess.correlation = 1.0 + 0.005 * weight;
				guesses.add(guess);

			}
		}

		// Rڂ瓊[錾̃C؂ꐄsiRڂȂ̂͏ԑ΍j
		if( args.agi.latestGameInfo.getDay() >= 3 ){

			// CO҂̃Xg擾
			List<Integer> mediums = args.agi.getEnableCOAgentNo(Role.MEDIUM, args.agi.latestGameInfo.getDay(), 0);

			VoteAnalyzer saidVote = VoteAnalyzer.loadSaidVote(args.agi);

			for( Vote vote : saidVote.voteList ){
				if( vote.getTarget() != null ){

					// [̐vfƂĂ̏d(菇݂肾ƌyȂ)
					double weight = 1.0;

					// 퓊[҂̏ꍇA菇݂Ƃďd݂
					if( mediums.size() >= 2 && mediums.indexOf(vote.getTarget().getAgentIdx()) != -1 ){
						weight *= 0.5;
					}
					// 퓊[҂Ⴂ̏ꍇA菇݂Ƃďd݂
					if( args.agi.isReceiveWolfJudge(vote.getTarget().getAgentIdx(), args.agi.latestGameInfo.getDay(), 0) ){
						weight *= 0.5;
					}

					AbstractCondition agentWolf = RoleCondition.getRoleCondition( vote.getAgent(), Role.WEREWOLF );
					AbstractCondition targetWolf = RoleCondition.getRoleCondition( vote.getTarget(), Role.WEREWOLF );

					Guess guess = new Guess();
					guess.condition = new AndCondition().addCondition(agentWolf).addCondition(targetWolf);
					guess.correlation = 1.0 - 0.4 * weight;
					guesses.add(guess);
				}
			}
		}

		// XgԂ
		return guesses;
	}

}
